
object Test {
  
  def main (argv:Array[String]):Unit = run()

  def empty[A] ():List[A] = List.empty()
  def cons[A] (v:A,l:List[A]):List[A] = List.merge(List.singleton(v),l)


  def xCoords (l:List[Point]):List[Double] = {
    if (l.isEmpty())
      empty()
    else
      cons(l.first().xCoord(),xCoords(l.rest()))
  }
  
  def colors (l:List[CPoint]):List[Color] = {
    if (l.isEmpty())
      empty()
    else
      cons(l.first().color(),colors(l.rest()))
  }


/*
  def badUpdate[A<:Point] (l:List[A]):Unit = {
    val p:Point = Point.cartesian(99,99)
    l.update(p)
  }
*/

  
  def run ():Unit = {
    
    val p:Point = Point.cartesian(40,50)
    val q:Point = Point.cartesian(400,500)
    val l:List[Point] = cons(p,cons(q,List.empty()))
    
    val cp:CPoint = CPoint.cartesian(10,20,Color.red())
    val cq:CPoint = CPoint.cartesian(100,200,Color.blue())
    val cl:List[CPoint] = cons(cp,cons(cq,List.empty()))

    println("l = " + l)
    println("cl = " + cl)
    println("xCoords(l) = " + xCoords(l))
    println("colors(cl) = " + colors(cl))

    // testing covariance:
    // println("xCoords(cl) = " + xCoords(cl))

    // testing update: [List must be invariant]
    // cl.update(CPoint.cartesian(1,2,Color.red()))
    // println("cl = " + cl)

    // testing find: [List must be invariant, or using find[U >: T] version
    // println("cl.find(cp) = " + cl.find(cp))
    // println("cl.find(CPoint.cartesian(44,55,green)) = " + 
    //         cl.find(CPoint.cartesian(44,55,Color.yellow())))
    
  }
}

